unit U_BSPrtInEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxCalendar, cxDropDownEdit, ComCtrls, ToolWin,
  cxGridLevel, cxGridCustomTableView, cxGridTableView, cxGridDBTableView,
  cxClasses, cxControls, cxGridCustomView, cxGrid, cxGridCustomPopupMenu,
  cxGridPopupMenu, ADODB, DBClient, cxButtonEdit, cxTextEdit, StdCtrls, ExtCtrls,
  cxLookAndFeels, cxLookAndFeelPainters, cxNavigator, dxDateRanges,
  dxBarBuiltInMenu, U_BaseInput, System.ImageList, Vcl.ImgList, dxSkinsCore,
  dxSkinsDefaultPainters, dxScrollbarAnnotations, cxImageList;

type
  TfrmBSPrtInEdit = class(TfrmBaseInput)
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column2: TcxGridDBColumn;
    v1SPName: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    cxGrid1Level1: TcxGridLevel;
    v1Column4: TcxGridDBColumn;
    DS_1: TDataSource;
    CDS_Sub: TClientDataSet;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    GPM_1: TcxGridPopupMenu;
    v1Column12: TcxGridDBColumn;
    v1FactoryName: TcxGridDBColumn;
    v1Column6: TcxGridDBColumn;
    v1SPSpec: TcxGridDBColumn;
    v1QtyUnit: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    Tv1Column1: TcxGridDBColumn;
    Tv1Column2: TcxGridDBColumn;
    Tv1Column3: TcxGridDBColumn;
    Tv1Column4: TcxGridDBColumn;
    Tv1Style: TcxGridDBColumn;
    Panel1: TPanel;
    ToolBar1: TToolBar;
    TBSave: TToolButton;
    ToolButton2: TToolButton;
    TBAdd1: TToolButton;
    TbAdd2: TToolButton;
    TBDel: TToolButton;
    ToolButton1: TToolButton;
    TBClose: TToolButton;
    ToolButton3: TToolButton;
    Tv1FromPurSId: TcxGridDBColumn;
    Tv1FromPurMId: TcxGridDBColumn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBAdd1Click(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure v1Column14PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1Column5PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure Tv1Column1PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure Tv1Column2PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure TbAdd2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure v1QtyUnitPropertiesButtonClick(Sender: TObject;
      AButtonIndex: Integer);
  private
    { Private declarations }
    function SaveCKData(): Boolean;
  public
    { Public declarations }
    FBCId, canshu3, FSTKName, FKHName: string;
  end;

var
  frmBSPrtInEdit: TfrmBSPrtInEdit;

implementation

uses
  U_DataLink, U_RTFun, U_ZDYHelp, U_ProductInfoSel, U_CompanySel,
  U_JWLPurchasePlanSel, U_GKManageSel, U_PurchasePlanSel;

{$R *.dfm}

procedure TfrmBSPrtInEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmBSPrtInEdit.TBAdd1Click(Sender: TObject);
begin
  try
    frmProductInfoSel := TfrmProductInfoSel.Create(Application);
    with frmProductInfoSel do
    begin
      FSTKName := Self.FSTKName;
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Append;
          FieldByName('IOTime').Value := Trim(FormatDateTime('yyyy-MM-dd', Now));
          FieldByName('StkCoNo').Value := '本厂仓库';
          FieldByName('StkCoName').Value := '本厂仓库';
          FieldByName('IOType').Value := '采购入库';
          FieldByName('P_Code').Value := frmProductInfoSel.CDS_1.fieldbyname('P_Code').value;
          FieldByName('P_Name').Value := frmProductInfoSel.CDS_1.fieldbyname('P_Name').value;
          FieldByName('P_Spec').Value := frmProductInfoSel.CDS_1.fieldbyname('P_Spec').value;
          FieldByName('Brand').Value := frmProductInfoSel.CDS_1.fieldbyname('Brand').value;
          FieldByName('QtyUnit').Value := frmProductInfoSel.CDS_1.fieldbyname('QtyUnit').value;
          FieldByName('Price').Value := frmProductInfoSel.CDS_1.fieldbyname('Price').value;
          FieldByName('Style').Value := '机物料';
        end;
      end;
    end;
  finally
    frmProductInfoSel.Free;
  end;
end;

function TfrmBSPrtInEdit.SaveCKData(): Boolean;
var
  Maxno, MBPIOID: string;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Sub.DisableControls;
    with CDS_Sub do
    begin
      First;
      while not eof do
      begin
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from BS_Product_IO where BPIOID=''' + Trim(CDS_Sub.fieldbyname('BPIOID').AsString) + '''');
          open;
        end;
        MBPIOID := Trim(ADOQueryTemp.fieldbyname('BPIOID').AsString);
        if Trim(MBPIOID) = '' then
        begin
          if not GetLSNo(ADOQueryCmd, Maxno, 'PR', 'BS_Product_IO', 3, 1) then
            raise Exception.Create('取入库编号失败！');
        end
        else
        begin
          Maxno := Trim(MBPIOID);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from BS_Product_IO where BPIOID=''' + Trim(Maxno) + '''');
          Open;
        end;
        with ADOQueryCmd do
        begin
          if Trim(MBPIOID) = '' then
          begin
            Append;
            FieldByName('Fillid').Value := Trim(Dcode);
            FieldByName('Filler').Value := Trim(DName);
          end
          else
          begin
            Edit;
            FieldByName('Editid').Value := Trim(Dcode);
            FieldByName('Editer').Value := Trim(DName);
            FieldByName('EditTime').Value := SGetServerDate(ADOQueryTemp);
          end;
          RTSetSaveDataCDS(ADOQueryCmd, Tv1, CDS_Sub, 'BS_Product_IO', 0);
          FieldByName('FromCoNo').Value := CDS_Sub.fieldbyname('FromCoNo').Value;
          FieldByName('StkCoNo').Value := CDS_Sub.fieldbyname('StkCoNo').Value;

//          FieldByName('FromPurNo').Value := CDS_Sub.fieldbyname('FromPurNo').Value;
//          FieldByName('FromPurMId').Value := CDS_Sub.fieldbyname('FromPurMId').Value;
//          FieldByName('FromPurSId').Value := CDS_Sub.fieldbyname('FromPurSId').Value;

          FieldByName('BPIOID').Value := Trim(Maxno);
          FieldByName('STKID').Value := Trim(Maxno);
          FieldByName('STKName').Value := FSTKName;
          FieldByName('IOFlag').Value := '入库';
          FieldByName('IOQtyFlag').Value := 1;
          Post;
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('Update BS_Product_IO Set  StkQty=(select Sum(isnull(Qty,0)*IOQtyFlag) from BS_Product_IO A where A.STKID=BS_Product_IO.BPIOID )');
          sql.Add(' where BPIOID=''' + Trim(Maxno) + '''');
          ExecSQL;
        end;
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select stkQty   from BS_Product_IO where BPIOID=''' + Trim(Maxno) + '''');
          Open;
        end;
        if ADOQueryTemp.FieldByName('stkQty').Value < 0 then
          raise Exception.Create('入库数量小于出库数量不能保存!');

        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('insert into Finance_Need_Up(UType,UDataId,UOperation,UOperator,UModule,UDetails)');
          sql.Add('values(' + quotedstr(FSTKName + '入库'));
          sql.Add(',' + quotedstr(Maxno));
          sql.Add(',''保存''   ');
          sql.Add(',' + quotedstr(DName));
          sql.Add(',' + quotedstr(trim(self.Caption)));
          sql.Add(',' + quotedstr(Maxno));
          sql.Add(')  ');
          ExecSQL;
        end;
        Edit;
        FieldByName('BPIOID').Value := Trim(Maxno);
        Post;
        Next;
      end;
    end;

    CDS_Sub.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;

    Result := True;
  except
    Result := False;
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
  end;

end;

procedure TfrmBSPrtInEdit.TBCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmBSPrtInEdit.FormDestroy(Sender: TObject);
begin
  inherited;
  frmBSPrtInEdit := nil;
end;

procedure TfrmBSPrtInEdit.FormShow(Sender: TObject);
var
  fsj: string;
begin
  inherited;
  ReadCxGrid(FSTKName + '入库登记', Tv1, '物料仓库');

  self.Caption := FSTKName + '入库登记';
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add(' select A.* ');
    sql.Add(' from BS_Product_IO A');
    sql.Add(' where BPIOID=''' + Trim(FBCId) + '''');
    Open;
  end;
  SCreateCDS(ADOQueryTemp, CDS_Sub);
  SInitCDSData(ADOQueryTemp, CDS_Sub);
end;

procedure TfrmBSPrtInEdit.TBDelClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if Trim(CDS_Sub.fieldbyname('BPIOID').AsString) <> '' then
  begin
    if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
      Exit;
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('exec P_Fin_Flow_Judge ');
      Sql.Add(' @FFIDS=' + quotedstr(Trim(CDS_Sub.fieldbyname('BPIOID').AsString)));
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
      Open;
    end;
    if ADOQueryTemp.FieldByName('intReturn').AsInteger = -1 then
    begin
      Application.MessageBox(PChar(ADOQueryTemp.fieldbyname('ShowMsg').AsString), '提示', 0);
      exit;
    end;
    try
      ADOQueryCmd.Connection.BeginTrans;
      with ADOQueryCmd do
      begin
        Close;
        Sql.Clear;
        sql.Add('insert into Finance_Need_Up(UType,UDataId,UOperation,UOperator,UModule,UDetails)       ');
        sql.Add('values(' + quotedstr(FSTKName + '入库'));
        sql.Add(',' + quotedstr(Trim(CDS_Sub.fieldbyname('BPIOID').AsString)));
        sql.Add(',''删除''   ');
        sql.Add(',' + quotedstr(DName));
        sql.Add(',' + quotedstr(trim(self.Caption)));
        sql.Add(',' + quotedstr(Trim(CDS_Sub.fieldbyname('BPIOID').AsString)));
        sql.Add(')  ');

        Sql.Add('exec P_BS_Product_In_Del ');
        Sql.Add(' @BPIOIDS=' + quotedstr(Trim(CDS_Sub.fieldbyname('BPIOID').AsString)));
        Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
        Sql.Add(',@DName=' + quotedstr(Trim(DName)));
        Open;
      end;
      if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
        raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
      ADOQueryCmd.Connection.CommitTrans;
      CDS_Sub.Delete;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    end;
  end
  else
  begin
    CDS_Sub.Delete;
  end;

end;

procedure TfrmBSPrtInEdit.TBSaveClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if CDS_Sub.Locate('IOTime', null, []) = True then
  begin
    Application.MessageBox('入库时间不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('IOType', null, []) = True then
  begin
    Application.MessageBox('入库类型不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('P_Name', null, []) = True then
  begin
    Application.MessageBox('品名不能为空!', '提示', 0);
    Exit;
  end;

  if CDS_Sub.Locate('Qty', null, []) = True then
  begin
    Application.MessageBox('数量不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('QtyUnit', null, []) = True then
  begin
    Application.MessageBox('数量单位不能为空!', '提示', 0);
    Exit;
  end;

  if SaveCKData() then
  begin
    Application.MessageBox('保存成功!', '提示', 0);
    ModalResult := 1;
    Exit;
  end;
end;

procedure TfrmBSPrtInEdit.ToolButton1Click(Sender: TObject);
begin
  WriteCxGrid(FSTKName + '入库登记', Tv1, '物料仓库');

end;

procedure TfrmBSPrtInEdit.ToolButton2Click(Sender: TObject);
begin
  try
    frmJWLPurchasePlanSel := TfrmJWLPurchasePlanSel.Create(Application);
    with frmJWLPurchasePlanSel do
    begin
      if ShowModal = 1 then
      begin
        with CDS_1 do
        begin
          First;
          while not Eof do
          begin
            if CDS_1.fieldbyname('SSel').AsBoolean then
            begin
              with Self.CDS_Sub do
              begin
                Append;
                FieldByName('IOType').Value := '采购入库';
                FieldByName('FromCoNo').Value := CDS_1.fieldbyname('SellNo').value;
                FieldByName('FromCoName').Value := CDS_1.fieldbyname('SellName').value;

                FieldByName('StkCoNo').Value := Trim(CDS_1.fieldbyname('BuyNo').AsString);
                FieldByName('StkCoName').Value := CDS_1.fieldbyname('BuyName').value;

                FieldByName('Brand').Value := CDS_1.fieldbyname('Brand').value;
                FieldByName('P_Code').Value := CDS_1.fieldbyname('Y_Code').value;
                FieldByName('P_Name').Value := CDS_1.fieldbyname('Y_Name').value;
                FieldByName('P_Spec').Value := CDS_1.fieldbyname('Y_Spec').value;
                FieldByName('P_Color').Value := CDS_1.fieldbyname('Y_Color').value;

                FieldByName('Qty').Value := CDS_1.fieldbyname('Qty').value;
                FieldByName('Price').Value := CDS_1.fieldbyname('Price').value;
                FieldByName('Amount').Value := CDS_1.fieldbyname('Amount').value;
                FieldByName('QtyUnit').Value := CDS_1.fieldbyname('QtyUnit').value;
                FieldByName('IOTime').Value := Trim(FormatDateTime('yyyy-MM-dd', Now));

                FieldByName('FromPurNo').Value := CDS_1.fieldbyname('PurNo').value;
                FieldByName('FromPurMId').Value := CDS_1.fieldbyname('PurMId').value;
                FieldByName('FromPurSId').Value := CDS_1.fieldbyname('PurSId').value;

              end;
            end;
            Next;
          end;
        end;
      end;
    end;
  finally
    frmJWLPurchasePlanSel.Free;
  end;
end;

procedure TfrmBSPrtInEdit.ToolButton3Click(Sender: TObject);
begin
  inherited;
//  i := CDS_Sub.RecordCount + 1;
  try
    frmPurchasePlanSel := TfrmPurchasePlanSel.Create(Application);
    with frmPurchasePlanSel do
    begin
      FSTKName := Self.FSTKName;
      if ShowModal = 1 then
      begin
        with CDS_1 do
        begin
          First;
          while not Eof do
          begin
            if CDS_1.FieldByName('SSel').AsBoolean then
            begin
              with CDS_Sub do
              begin
                append;
                FieldByName('IOTime').Value := Trim(FormatDateTime('yyyy-MM-dd', now));
                FieldByName('StkCoNo').Value := '本厂仓库';
                FieldByName('StkCoName').Value := '本厂仓库';
                FieldByName('FromCoName').Value := frmPurchasePlanSel.CDS_1.fieldbyname('SellName').value;
                FieldByName('IOType').Value := '采购入库';
                FieldByName('P_Code').Value := frmPurchasePlanSel.CDS_1.fieldbyname('Y_Code').value;
                FieldByName('P_Name').Value := frmPurchasePlanSel.CDS_1.fieldbyname('Y_Name').value;
                FieldByName('P_Spec').Value := frmPurchasePlanSel.CDS_1.fieldbyname('Y_Spec').value;
                FieldByName('Style').Value := frmPurchasePlanSel.CDS_1.fieldbyname('C_Degree').value;
                FieldByName('Brand').Value := frmPurchasePlanSel.CDS_1.fieldbyname('Brand').value;
                FieldByName('QtyUnit').Value := frmPurchasePlanSel.CDS_1.fieldbyname('QtyUnit').value;
                FieldByName('Price').Value := frmPurchasePlanSel.CDS_1.fieldbyname('Price').value;

                FieldByName('FromPurSId').Value := frmPurchasePlanSel.CDS_1.fieldbyname('PurSId').value;
                FieldByName('FromPurMId').Value := frmPurchasePlanSel.CDS_1.fieldbyname('PurMId').value;
              end;

            end;
            next;
          end;
        end;
      end;
    end;
  finally
    frmPurchasePlanSel.Free;
  end;
end;

procedure TfrmBSPrtInEdit.TbAdd2Click(Sender: TObject);
//var
//  i: Integer;
begin
  inherited;
//  i := CDS_Sub.RecordCount + 1;
  try
    frmGKManageSel := TfrmGKManageSel.Create(Application);
    with frmGKManageSel do
    begin
      FSTKName := Self.FSTKName;
      if ShowModal = 1 then
      begin
        with CDS_HZ do
        begin
          First;
          while not Eof do
          begin
            if CDS_HZ.FieldByName('SSel').AsBoolean then
            begin
              with CDS_Sub do
              begin
                append;
                FieldByName('IOTime').Value := Trim(FormatDateTime('yyyy-MM-dd', Now));
                FieldByName('StkCoNo').Value := '本厂仓库';
                FieldByName('StkCoName').Value := '本厂仓库';
                FieldByName('IOType').Value := '采购入库';
                FieldByName('P_Code').Value := frmGKManageSel.CDS_HZ.fieldbyname('GKBH').value;
                FieldByName('P_Name').Value := frmGKManageSel.CDS_HZ.fieldbyname('GKKH').value;
                FieldByName('P_Spec').Value := frmGKManageSel.CDS_HZ.fieldbyname('GKLength').value;
//                FieldByName('Qty').Value := frmGKManageSel.CDS_HZ.fieldbyname('kcqty').value;
                FieldByName('Style').Value := '钢筘';
              end;

            end;
            next;
          end;
        end;
      end;
    end;
  finally
    frmGKManageSel.Free;
  end;
end;

procedure TfrmBSPrtInEdit.Tv1Column1PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      FCoType := '客户';
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('StkCoNo').Value := Trim(CDS_1.fieldbyname('CoCode').AsString);
          FieldByName('StkCoName').Value := Trim(CDS_1.fieldbyname('CoAbbrName').AsString);
        end;
      end;
    end;
  finally
    frmCompanySel.Free;
  end;

end;

procedure TfrmBSPrtInEdit.Tv1Column2PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    if CDS_Sub.FieldByName('style').Value = '机物料' then
    begin
      frmProductInfoSel := TfrmProductInfoSel.Create(Application);
      with frmProductInfoSel do
      begin
        FSTKName := Self.FSTKName;
        if ShowModal = 1 then
        begin
          with Self.CDS_Sub do
          begin
            Edit;
            FieldByName('P_Code').Value := frmProductInfoSel.CDS_1.fieldbyname('P_Code').value;
            FieldByName('P_Name').Value := frmProductInfoSel.CDS_1.fieldbyname('P_Name').value;
            FieldByName('P_Spec').Value := frmProductInfoSel.CDS_1.fieldbyname('P_Spec').value;
            FieldByName('QtyUnit').Value := frmProductInfoSel.CDS_1.fieldbyname('QtyUnit').value;
            FieldByName('Price').Value := frmProductInfoSel.CDS_1.fieldbyname('Price').value;
          end;
        end;
      end;
    end
    else if CDS_Sub.FieldByName('style').Value = '钢筘' then
    begin
      frmGKManageSel := TfrmGKManageSel.Create(Application);
      with frmGKManageSel do
      begin
        FSTKName := Self.FSTKName;
        if ShowModal = 1 then
        begin
          with Self.CDS_Sub do
          begin
            Edit;
            FieldByName('P_Code').Value := frmGKManageSel.CDS_HZ.fieldbyname('GKBH').value;
            FieldByName('P_Name').Value := frmGKManageSel.CDS_HZ.fieldbyname('GKKH').value;
            FieldByName('P_Spec').Value := frmGKManageSel.CDS_HZ.fieldbyname('GKLength').value;
          end;
        end;
      end;
    end;

  finally
    frmGKManageSel.Free;
  end;
end;

procedure TfrmBSPrtInEdit.v1Column14PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin

  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      FCoType := '供应商';
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('FromCoNo').Value := Trim(CDS_1.fieldbyname('CoCode').AsString);
          FieldByName('FromCoName').Value := Trim(CDS_1.fieldbyname('CoAbbrName').AsString);
        end;
      end;
    end;
  finally
    frmCompanySel.Free;
  end;

end;

procedure TfrmBSPrtInEdit.v1Column5PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'StkPosition';
      flagname := '库位';
      MainType := FSTKName;
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('StkPosition').Value := Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmBSPrtInEdit.v1QtyUnitPropertiesButtonClick(Sender: TObject;
  AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'QtyUnit';
      flagname := '单位';
      MainType := FSTKName;
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('QtyUnit').Value := Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

end.

